Bug 1122951 - [GSS] (6.4.0) ElectionPolicy is called twice during cluster change/merge (race condition)
Summary: [GSS] (6.4.0) ElectionPolicy is called twice during cluster change/merge (rac...
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: None
Product: JBoss Enterprise Application Platform 6
Classification: JBoss
Component: Clustering
Version: 6.2.0
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: DR1
: EAP 6.4.0
Assignee: Paul Ferraro
QA Contact: Jitka Kozana
URL:
Whiteboard:
Depends On:
Blocks: 1133758 1133828
TreeView+ depends on / blocked
 
Reported: 2014-07-24 13:09 UTC by wfink
Modified: 2019-08-19 12:45 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
: 1133758 1133828 (view as bug list)
Environment:
Last Closed:
Type: Bug


Attachments (Terms of Use)

Description wfink 2014-07-24 13:09:03 UTC
Description of problem:
If a cluster need to elect the master node it might happen that the ElectionPolicy is called multiple times by different threads.

13:40:13,832 INFO  [org.jboss.as.quickstarts.cluster.hasingleton.service.ejb.CustomElectionPolicy] (notification-thread-0) CustomElectionPolicy.Elect(). Candidates Size: 1
13:40:13,865 INFO  [org.jboss.as.quickstarts.cluster.hasingleton.service.ejb.CustomElectionPolicy] (AsynchViewChangeHandler Thread) CustomElectionPolicy.Elect(). Candidates Size: 2

This might happen if one server was shutdown or after split/heal the cluster. It might happen that the singleton was not correct deactivated on one node and keep running twice.

Comment 1 wfink 2014-07-24 13:11:21 UTC
From the analysis it will be a race between JGroups view change event and Infinispan cacheModifiedEvent.

Comment 4 Ladislav Thon 2014-11-05 09:02:37 UTC
Verified with EAP 6.4.0.DR8.


Note You need to log in before you can comment on or make changes to this bug.